

library(maptools); library(rgdal); library(rgeos); library(foreign)
library("foreach"); library("doParallel")
##library(ggplot2)
##
simfolder <- paste('/mnt/shares/lsa/base/',sep=''); 
st <- c('AL','AR','AZ','CA','DE','FL','GA','IL','LA','MD','MS','NC','NM','NV','NY','SC','TN','TX','VA')
w <- as.data.frame(st); w$sfx <- '_sp'; 


###################


for (j in c(1:19) ){ st<-w$st[j]; print(st)
	files<-list.files(paste(simfolder,st,sep='')); files<-files[regexpr('sim',files)==1][1]; sldl_dists <- as.numeric(substr(files,4,99));
	v <- read.delim(paste(simfolder,st,'/votes_java2.txt',sep=''),header=T)

	## RACE-CONSCIOUS SIMULATIONS:
	stfolder <- paste(simfolder,st,'/race',w$sfx[j],sep='');
	
	rlist<-mclapply(1:1000, function(i){
		a <- read.delim(paste(stfolder,'/',i,'.txt',sep=''), header=F); a$V1<-as.character(a$V1);  out<-as.data.frame(t(a[2:dim(a)[1],2])); names(out)<-a[2:dim(a)[1],1]; v$sim <- as.numeric(a[1,]);
		ag <- aggregate(v[,c(12:37)],by=list(v$sim),FUN=function(k) sum(k,na.rm=T));
		ag$dist<-substr(ag$Group.1,1,3); ##q<-summary(as.factor(v$cty)); q<-q[q>1]; d$spctys<-length(q); d$ctyfrags<-dim(a)[1] ##58 split ctys ##ag$ctyfrags <- as.numeric(lapply(ag$dist, function(i) length(unique(v$cty[v$sim==i])) )) ##ag$mcdfrags <- as.numeric(lapply(ag$dist, function(i) length(unique(v$mcd[v$sim==i & v$mcd!="99999"])) ))
		ag$Brsh <- ag$BRvotes/(ag$BRvotes+ag$BDvotes); ag$Hrsh <- ag$HRvotes/(ag$HRvotes+ag$HDvotes);
		ag$bshareDEMS <- ag$BDvotes/(ag$BDvotes+ag$HDvotes+ag$ODvotes); ag$bshareREPS <- ag$BRvotes/(ag$BRvotes+ag$HRvotes+ag$ORvotes); ## black share among all Obama voters; 
		ag$hshareDEMS <- ag$HDvotes/(ag$BDvotes+ag$HDvotes+ag$ODvotes); ag$hshareREPS <- ag$HRvotes/(ag$BRvotes+ag$HRvotes+ag$ORvotes); ## hispanic share among all Obama voters; 
		ag$bhshareDEMS <- (ag$BDvotes+ag$HDvotes)/ag$Obama; ag$bhshareREPS <- (ag$BRvotes+ag$HRvotes)/ag$Romney; ## black+hispanic share among all Obama voters;
		ag$type<-""; ag$rsh<-(ag$BRvotes+ag$HRvotes+ag$ORvotes)/(ag$BRvotes+ag$HRvotes+ag$ORvotes+ag$BDvotes+ag$HDvotes+ag$ODvotes)
		ag$type[ag$bshareDEMS+ag$hshareDEMS>0.5 & ag$Brsh<0.5 & ag$Hrsh<0.5 & ag$rsh<0.5 & ag$bshareDEMS>ag$hshareDEMS] <- "BlackCoalition"; ag$type[ag$bshareDEMS+ag$hshareDEMS>0.5 & ag$Brsh>0.5 & ag$Hrsh>0.5 & ag$rsh>0.5 & ag$bshareDEMS>ag$hshareDEMS] <- "BlackCoalition"; 
		ag$type[ag$bshareDEMS+ag$hshareDEMS>0.5 & ag$Brsh<0.5 & ag$Hrsh<0.5 & ag$rsh<0.5 & ag$bshareDEMS<ag$hshareDEMS] <- "HispCoalition"; ag$type[ag$bshareDEMS+ag$hshareDEMS>0.5 & ag$Brsh>0.5 & ag$Hrsh>0.5 & ag$rsh>0.5 & ag$bshareDEMS<ag$hshareDEMS] <- "HispCoalition"; 
		ag$type[ag$bshareDEMS>0.5 & ag$Brsh<0.5 & ag$rsh<0.5] <- "Black"; ag$type[ag$bshareREPS>0.5 & ag$Brsh>0.5 & ag$rsh>0.5] <- "Black";
		ag$type[ag$hshareDEMS>0.5 & ag$Hrsh<0.5 & ag$rsh<0.5] <- "Hisp"; ag$type[ag$hshareREPS>0.5 & ag$Hrsh>0.5 & ag$rsh>0.5] <- "Hisp"; 
		ag$right<-ag$BRvotes+ag$HRvotes+ag$ORvotes; ag$left<-ag$BDvotes+ag$HDvotes+ag$ODvotes; ag$romshare<-ag$right/(ag$right+ag$left);  
		ag$BshDems<-ag$BDvotes/ag$left; ag$BshReps<-ag$BRvotes/ag$right; ag$BshMajPty<-ag$BshDems; ag$BshMajPty[ag$right>ag$left]<-ag$BshReps[ag$right>ag$left]; 
		ag$HshDems<-ag$HDvotes/ag$left; ag$HshReps<-ag$HRvotes/ag$right; ag$HshMajPty<-ag$HshDems; ag$HshMajPty[ag$right>ag$left]<-ag$HshReps[ag$right>ag$left];
		ag$sim<-i; names(ag)[1]<-'district'; out <- ag[,c('sim','district','type','BshMajPty','HshMajPty')]
		return(out);
	} , mc.cores=1000); res<-NULL; for(i in 1:length(rlist)){res<-rbind(res,rlist[[i]])}
	write.table(res, paste(simfolder,st,'/sim',sldl_dists,'/raceSP_dists.txt',sep=''), row.names=F,col.names=T,sep='\t'); print(paste(simfolder,st,'/sim',sldl_dists,'/race4_dists.txt',sep=''))
	

	## RACE-BLIND SIMULATIONS:
	stfolder <- paste(simfolder,st,'/blind',w$sfx[j],sep='');
	rlist<-mclapply(1:1000, function(i){
		a <- read.delim(paste(stfolder,'/',i,'.txt',sep=''), header=F); a$V1<-as.character(a$V1);  out<-as.data.frame(t(a[2:dim(a)[1],2])); names(out)<-a[2:dim(a)[1],1]; v$sim <- as.numeric(a[1,]);
		ag <- aggregate(v[,c(12:37)],by=list(v$sim),FUN=function(k) sum(k,na.rm=T));
		ag$dist<-substr(ag$Group.1,1,3); ##q<-summary(as.factor(v$cty)); q<-q[q>1]; d$spctys<-length(q); d$ctyfrags<-dim(a)[1] ##58 split ctys ##ag$ctyfrags <- as.numeric(lapply(ag$dist, function(i) length(unique(v$cty[v$sim==i])) )) ##ag$mcdfrags <- as.numeric(lapply(ag$dist, function(i) length(unique(v$mcd[v$sim==i & v$mcd!="99999"])) ))
		ag$Brsh <- ag$BRvotes/(ag$BRvotes+ag$BDvotes); ag$Hrsh <- ag$HRvotes/(ag$HRvotes+ag$HDvotes);
		ag$bshareDEMS <- ag$BDvotes/(ag$BDvotes+ag$HDvotes+ag$ODvotes); ag$bshareREPS <- ag$BRvotes/(ag$BRvotes+ag$HRvotes+ag$ORvotes); ## black share among all Obama voters; 
		ag$hshareDEMS <- ag$HDvotes/(ag$BDvotes+ag$HDvotes+ag$ODvotes); ag$hshareREPS <- ag$HRvotes/(ag$BRvotes+ag$HRvotes+ag$ORvotes); ## hispanic share among all Obama voters; 
		ag$bhshareDEMS <- (ag$BDvotes+ag$HDvotes)/ag$Obama; ag$bhshareREPS <- (ag$BRvotes+ag$HRvotes)/ag$Romney; ## black+hispanic share among all Obama voters;
		ag$type<-""; ag$rsh<-(ag$BRvotes+ag$HRvotes+ag$ORvotes)/(ag$BRvotes+ag$HRvotes+ag$ORvotes+ag$BDvotes+ag$HDvotes+ag$ODvotes)
		ag$type[ag$bshareDEMS+ag$hshareDEMS>0.5 & ag$Brsh<0.5 & ag$Hrsh<0.5 & ag$rsh<0.5 & ag$bshareDEMS>ag$hshareDEMS] <- "BlackCoalition"; ag$type[ag$bshareDEMS+ag$hshareDEMS>0.5 & ag$Brsh>0.5 & ag$Hrsh>0.5 & ag$rsh>0.5 & ag$bshareDEMS>ag$hshareDEMS] <- "BlackCoalition"; 
		ag$type[ag$bshareDEMS+ag$hshareDEMS>0.5 & ag$Brsh<0.5 & ag$Hrsh<0.5 & ag$rsh<0.5 & ag$bshareDEMS<ag$hshareDEMS] <- "HispCoalition"; ag$type[ag$bshareDEMS+ag$hshareDEMS>0.5 & ag$Brsh>0.5 & ag$Hrsh>0.5 & ag$rsh>0.5 & ag$bshareDEMS<ag$hshareDEMS] <- "HispCoalition"; 
		ag$type[ag$bshareDEMS>0.5 & ag$Brsh<0.5 & ag$rsh<0.5] <- "Black"; ag$type[ag$bshareREPS>0.5 & ag$Brsh>0.5 & ag$rsh>0.5] <- "Black";
		ag$type[ag$hshareDEMS>0.5 & ag$Hrsh<0.5 & ag$rsh<0.5] <- "Hisp"; ag$type[ag$hshareREPS>0.5 & ag$Hrsh>0.5 & ag$rsh>0.5] <- "Hisp"; 
		ag$right<-ag$BRvotes+ag$HRvotes+ag$ORvotes; ag$left<-ag$BDvotes+ag$HDvotes+ag$ODvotes; ag$romshare<-ag$right/(ag$right+ag$left);  
		ag$BshDems<-ag$BDvotes/ag$left; ag$BshReps<-ag$BRvotes/ag$right; ag$BshMajPty<-ag$BshDems; ag$BshMajPty[ag$right>ag$left]<-ag$BshReps[ag$right>ag$left]; 
		ag$HshDems<-ag$HDvotes/ag$left; ag$HshReps<-ag$HRvotes/ag$right; ag$HshMajPty<-ag$HshDems; ag$HshMajPty[ag$right>ag$left]<-ag$HshReps[ag$right>ag$left];
		ag$sim<-i; names(ag)[1]<-'district'; out <- ag[,c('sim','district','type','BshMajPty','HshMajPty')]
		return(out);
	} , mc.cores=1000); res<-NULL; for(i in 1:length(rlist)){res<-rbind(res,rlist[[i]])}
	write.table(res, paste(simfolder,st,'/sim',sldl_dists,'/blindSP_dists.txt',sep=''), row.names=F,col.names=T,sep='\t'); print(paste(simfolder,st,'/sim',sldl_dists,'/blind_dists.txt',sep=''))
	
}




############  (FEBRUARY 2020):

pdf('/mnt/shares/lsa/base/R/Simulations_byDistrict_BlackShareOfMajPty.pdf',width=8.5,height=11)
for (s in 1:dim(w)[1]){ st<-w$st[s]; print(st)
	files<-list.files(paste(simfolder,st,sep='')); files<-files[regexpr('sim',files)==1][1]; sldl_dists <- as.numeric(substr(files,4,99));
	e <- read.delim(paste(simfolder,st,'/sim',sldl_dists,'/enact_dists.txt',sep=''),header=T)
	e$right<-e$BRvotes+e$HRvotes+e$ORvotes; e$left<-e$BDvotes+e$HDvotes+e$ODvotes; e$romshare<-e$right/(e$right+e$left);  
	e$BshDems<-e$BDvotes/e$left; e$BshReps<-e$BRvotes/e$right; e$BshMajPty<-e$BshDems; e$BshMajPty[e$right>e$left]<-e$BshReps[e$right>e$left]; e<-e[order(e$BshMajPty),]

	res <- read.delim(paste(simfolder,st,'/sim',sldl_dists,'/blindSP_dists.txt',sep=''), header=T); res$pch=1; res$pch[res$type %in% c("Black","BlackCoalition")]<-8; res$col<-"gray"; res$col[res$pch==8]<-"black"
	m<-c(res$BshMajPty,e$BshMajPty); 
	par(mar=c(6.0,14.6,3,0.2))
	plot(sort(e$BshMajPty),1:dim(e)[1],main=paste('\n',st,': ',sldl_dists,' districts (Race-Blind Simulations)',sep=''),ylim=c(sldl_dists/60,1.06*dim(e)[1]),xlim=c(min(m),max(m)),col="red",type="n",yaxt="n",ylab="",xlab="")
	lines(c(0.5,0.5),c(-100,dim(e)[1]+0.5),lty="dashed",col="gray")
	for(i in 1:dim(e)[1]){lines(c(-1,2),c(i,i),lty="dashed",col="gray",lwd=1);}
	for(i in 1:max(res$sim)){
		resi<-res[res$sim==i,]; resi<-resi[order(resi$BshMajPty),]; points(resi$BshMajPty,1:sldl_dists+runif(sldl_dists,-0.2,0.2),pch=resi$pch,cex=0.5,col=resi$col)
	}
	e$pch<- 1; e$pch[e$type %in% c("Black","BlackCoalition")]<-8; points(e$BshMajPty,1:dim(e)[1],col="red",pch=e$pch)
	title(xlab="African-American Share of the Voters Supporting the\nMajority Party in the District", cex.lab=1.0,mgp=c(3.0, 1.70, 0))
	yl <- ( paste('District with the ',seq(from=5,to=dim(e)[1],by=5),'th-Largest African-American Share',sep='') ); ## 
	axis(2, at=1+dim(e)[1]-seq(from=5,to=dim(e)[1],by=5), cex.axis=0.7, labels=(yl), mgp=c(1.5, 0.6, 0) ,las=1)
	axis(2, at=dim(e)[1], cex.axis=0.7, labels='District with the Largest African-American Share', mgp=c(1.3, 0.6, 0) ,las=1)		
	legend("top", c("Black Opportunity Districts in the 1,000 Race-Blind Computer-Simulated House Districting Plans","Non-Opportunity Districts in the 1,000 Race-Blind Computer-Simulated House Districting Plans","Black Opportunity Districts in the Enacted State House Plan (as of 2016)","Non-Opportunity Districts in the Enacted State House Plan (as of 2016)")
	, pch=c(8,1,8,1), cex=c(0.7,0.7,0.7,0.7), pt.cex=c(1,1,1,1), col=c("black","gray","red","red"), text.col=c("black","gray","red","red"), title.col=c("black") ,bty="y" )

	res <- read.delim(paste(simfolder,st,'/sim',sldl_dists,'/raceSP_dists.txt',sep=''), header=T); res<-res[res$BshMajPty!="Error in file(file, \\rt\\) : cannot open the connection\n",]; res$BshMajPty<-as.numeric(as.character(res$BshMajPty)); res$HshMajPty<-as.numeric(as.character(res$HshMajPty)); res$sim<-as.numeric(as.character(res$sim))
	res$pch=1; res$pch[res$type %in% c("Black","BlackCoalition")]<-8; res$col<-"gray"; res$col[res$pch==8]<-"black"
	m<-c(res$BshMajPty,e$BshMajPty); 
	par(mar=c(6.0,14.6,3,0.2))
	plot(sort(e$BshMajPty),1:dim(e)[1],main=paste('\n',st,': ',sldl_dists,' districts (Race-Conscious Simulations)',sep=''),ylim=c(sldl_dists/60,1.06*dim(e)[1]),xlim=c(min(m),max(m)),col="red",type="n",yaxt="n",ylab="",xlab="")
	lines(c(0.5,0.5),c(-100,dim(e)[1]+0.5),lty="dashed",col="gray")
	for(i in 1:dim(e)[1]){lines(c(-1,2),c(i,i),lty="dashed",col="gray",lwd=1);}
	for(i in unique(res$sim)){
		resi<-res[res$sim==i,]; resi<-resi[order(resi$BshMajPty),]; points(resi$BshMajPty,1:sldl_dists+runif(sldl_dists,-0.2,0.2),pch=resi$pch,cex=0.5,col=resi$col)
	}
	e$pch<- 1; e$pch[e$type %in% c("Black","BlackCoalition")]<-8; points(e$BshMajPty,1:dim(e)[1],col="red",pch=e$pch)
		##points(sort(e$BshMajPty),1:dim(e)[1],col="red",pch=8)
	title(xlab="African-American Share of the Voters Supporting the\nMajority Party in the District", cex.lab=1.0,mgp=c(3.0, 1.70, 0))
	yl <- ( paste('District with the ',seq(from=5,to=dim(e)[1],by=5),'th-Largest African-American Share',sep='') ); ## 
	axis(2, at=1+dim(e)[1]-seq(from=5,to=dim(e)[1],by=5), cex.axis=0.7, labels=(yl), mgp=c(1.5, 0.6, 0) ,las=1)
	axis(2, at=dim(e)[1], cex.axis=0.7, labels='District with the Largest African-American Share', mgp=c(1.3, 0.6, 0) ,las=1)		
	legend("top", c("Black Opportunity Districts in the 1,000 Race-Conscious Computer-Simulated House Districting Plans","Non-Opportunity Districts in the 1,000 Race-Conscious Computer-Simulated House Districting Plans","Black Opportunity Districts in the Enacted House Plan (as of 2016)","Non-Opportunity Districts in the Enacted House Plan (as of 2016)")
	, pch=c(8,1,8,1), cex=c(0.7,0.7,0.7,0.7), pt.cex=c(1,1,1,1), col=c("black","gray","red","red"), text.col=c("black","gray","red","red"), title.col=c("black") ,bty="y" )

}
dev.off()



pdf('/mnt/shares/lsa/base/R/Simulations_byDistrict_HispanicShareOfMajPty.pdf',width=8.5,height=11)
for (s in 1:dim(w)[1]){ st<-w$st[s]; print(st)
	files<-list.files(paste(simfolder,st,sep='')); files<-files[regexpr('sim',files)==1][1]; sldl_dists <- as.numeric(substr(files,4,99));
	e <- read.delim(paste(simfolder,st,'/sim',sldl_dists,'/enact_dists.txt',sep=''),header=T)
	e$right<-e$BRvotes+e$HRvotes+e$ORvotes; e$left<-e$BDvotes+e$HDvotes+e$ODvotes; e$romshare<-e$right/(e$right+e$left);  
	e$HshDems<-e$HDvotes/e$left; e$HshReps<-e$HRvotes/e$right; e$HshMajPty<-e$HshDems; e$HshMajPty[e$right>e$left]<-e$HshReps[e$right>e$left]; e<-e[order(e$HshMajPty),]

	res <- read.delim(paste(simfolder,st,'/sim',sldl_dists,'/blindSP_dists.txt',sep=''), header=T); res$pch=1; res$pch[res$type %in% c("Hisp","HispCoalition")]<-8; res$col<-"gray"; res$col[res$pch==8]<-"black"
	m<-c(res$HshMajPty,e$HshMajPty); 
	par(mar=c(6.0,14.6,3,0.2))
	plot(sort(e$HshMajPty),1:dim(e)[1],main=paste('\n',st,': ',sldl_dists,' districts (Race-Blind Simulations)',sep=''),ylim=c(sldl_dists/60,1.06*dim(e)[1]),xlim=c(min(m),max(m)),col="red",type="n",yaxt="n",ylab="",xlab="")
	lines(c(0.5,0.5),c(-100,dim(e)[1]+0.5),lty="dashed",col="gray")
	for(i in 1:dim(e)[1]){lines(c(-1,2),c(i,i),lty="dashed",col="gray",lwd=1);}
	for(i in 1:max(res$sim)){
		resi<-res[res$sim==i,]; resi<-resi[order(resi$HshMajPty),]; points(resi$HshMajPty,1:sldl_dists+runif(sldl_dists,-0.2,0.2),pch=resi$pch,cex=0.5,col=resi$col)
	}
	e$pch<- 1; e$pch[e$type %in% c("Hisp","HispCoalition")]<-8; points(e$HshMajPty,1:dim(e)[1],col="red",pch=e$pch)
	title(xlab="Hispanic Share of the Voters Supporting the\nMajority Party in the District", cex.lab=1.0,mgp=c(3.0, 1.70, 0))
	yl <- ( paste('District with the ',seq(from=5,to=dim(e)[1],by=5),'th-Largest Hispanic Share',sep='') ); ## 
	axis(2, at=1+dim(e)[1]-seq(from=5,to=dim(e)[1],by=5), cex.axis=0.7, labels=(yl), mgp=c(1.5, 0.6, 0) ,las=1)
	axis(2, at=dim(e)[1], cex.axis=0.7, labels='District with the Largest Hispanic Share', mgp=c(1.3, 0.6, 0) ,las=1)		
	legend("top", c("Hispanic Opportunity Districts in the 1,000 Race-Blind Computer-Simulated House Districting Plans","Non-Opportunity Districts in the 1,000 Race-Blind Computer-Simulated House Districting Plans","Hispanic Opportunity Districts in the Enacted State House Plan (as of 2016)","Non-Opportunity Districts in the Enacted State House Plan (as of 2016)")
	, pch=c(8,1,8,1), cex=c(0.7,0.7,0.7,0.7), pt.cex=c(1,1,1,1), col=c("black","gray","red","red"), text.col=c("black","gray","red","red"), title.col=c("black"), bty="y" )

	res <- read.delim(paste(simfolder,st,'/sim',sldl_dists,'/raceSP_dists.txt',sep=''), header=T); res<-res[res$BshMajPty!="Error in file(file, \\rt\\) : cannot open the connection\n",]; res$BshMajPty<-as.numeric(as.character(res$BshMajPty)); res$HshMajPty<-as.numeric(as.character(res$HshMajPty)); res$sim<-as.numeric(as.character(res$sim))
	res$pch=1; res$pch[res$type %in% c("Hisp","HispCoalition")]<-8; res$col<-"gray"; res$col[res$pch==8]<-"black"
	m<-c(res$HshMajPty,e$HshMajPty); 
	par(mar=c(6.0,14.6,3,0.2))
	plot(sort(e$HshMajPty),1:dim(e)[1],main=paste('\n',st,': ',sldl_dists,' districts (Race-Conscious Simulations)',sep=''),ylim=c(sldl_dists/60,1.06*dim(e)[1]),xlim=c(min(m),max(m)),col="red",type="n",yaxt="n",ylab="",xlab="")
	lines(c(0.5,0.5),c(-100,dim(e)[1]+0.5),lty="dashed",col="gray")
	for(i in 1:dim(e)[1]){lines(c(-1,2),c(i,i),lty="dashed",col="gray",lwd=1);}
	for(i in unique(res$sim)){
		resi<-res[res$sim==i,]; resi<-resi[order(resi$HshMajPty),]; points(resi$HshMajPty,1:sldl_dists+runif(sldl_dists,-0.2,0.2),pch=resi$pch,cex=0.5,col=resi$col)
	}
	e$pch<- 1; e$pch[e$type %in% c("Hisp","HispCoalition")]<-8; points(e$HshMajPty,1:dim(e)[1],col="red",pch=e$pch)
	title(xlab="Hispanic Share of the Voters Supporting the\nMajority Party in the District", cex.lab=1.0,mgp=c(3.0, 1.70, 0))
	yl <- ( paste('District with the ',seq(from=5,to=dim(e)[1],by=5),'th-Largest Hispanic Share',sep='') ); ## 
	axis(2, at=1+dim(e)[1]-seq(from=5,to=dim(e)[1],by=5), cex.axis=0.7, labels=(yl), mgp=c(1.5, 0.6, 0) ,las=1)
	axis(2, at=dim(e)[1], cex.axis=0.7, labels='District with the Largest Hispanic Share', mgp=c(1.3, 0.6, 0) ,las=1)		
	legend("top", c("Hispanic Opportunity Districts in the 1,000 Race-Conscious Computer-Simulated House Districting Plans","Non-Opportunity Districts in the 1,000 Race-Conscious Computer-Simulated House Districting Plans","Hispanic Opportunity Districts in the Enacted House Plan (as of 2016)","Non-Opportunity Districts in the Enacted House Plan (as of 2016)")
	, pch=c(8,1,8,1), cex=c(0.7,0.7,0.7,0.7), pt.cex=c(1,1,1,1), col=c("black","gray","red","red"), text.col=c("black","gray","red","red"), title.col=c("black") ,bty="y" )

}
dev.off()



#########################################################


